diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/EntityCategory.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/EntityCategory.java
index eb1600c4f..92f79c0eb 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/EntityCategory.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/EntityCategory.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.modelviewer.categories;
 
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.modelviewer.ModelViewerScreen;
 import net.minecraft.client.gui.modelviewer.categories.entries.entity.DispatcherEntry;
 import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntityArmoredZombieEntry;
 import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntityBoatEntry;
@@ -16,8 +16,8 @@ import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntityShee
 import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntitySlimeEntry;
 import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntityTNTEntry;
 import net.minecraft.client.gui.modelviewer.categories.entries.entity.EntityWolfEntry;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
-import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
+import net.minecraft.client.gui.modelviewer.elements.ListenerTextFieldElement;
+import net.minecraft.client.gui.modelviewer.elements.TextCycleElement;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.Mob;
@@ -33,11 +33,11 @@ import java.util.List;
 public class EntityCategory extends ModelViewerCategory{
     public HashMap<Class<? extends Entity>, EntityEntry<?>> entryMap = new HashMap<>();
     public List<EntityEntry<?>> entryList = new ArrayList<>();
-    public GuiListenerTextField entityName;
-    public GuiTextCycle<Integer> entityVariant;
+    public ListenerTextFieldElement entityName;
+    public TextCycleElement<Integer> entityVariant;
     public EntityEntry<?> currentEntry = EntityEntry.blankEntry;
     public Entity displayEntity;
-    public EntityCategory(GuiModelViewer modelViewer) {
+    public EntityCategory(ModelViewerScreen modelViewer) {
         super(modelViewer);
         createEntries();
     }
@@ -87,11 +87,11 @@ public class EntityCategory extends ModelViewerCategory{
     }
 
     @Override
-    public void addContextButtons(List<GuiButton> buttonList) {
-        GuiButton lastButton = buttonList.get(buttonList.size()-1);
+    public void addContextButtons(List<ButtonElement> buttonList) {
+        ButtonElement lastButton = buttonList.get(buttonList.size()-1);
         boolean isLiving = displayEntity instanceof Mob;
         if (isLiving){
-            entityVariant = new GuiTextCycle<Integer>(modelViewer, mc.fontRenderer, modelViewer.width - 120, lastButton.yPosition + 21, 120, 20, 0) {
+            entityVariant = new TextCycleElement<Integer>(modelViewer, mc.font, modelViewer.width - 120, lastButton.yPosition + 21, 120, 20, 0) {
                 @Override
                 public Integer cycleElement(Integer current, int offset) {
                     return (current + offset) & 0xFF;
@@ -116,7 +116,7 @@ public class EntityCategory extends ModelViewerCategory{
             entityVariant.textField.setPrefaceText("Variant: ");
             buttonList.add(entityVariant);
 
-            entityName = new GuiListenerTextField(modelViewer, mc.fontRenderer, modelViewer.width - 120, entityVariant.yPosition + 21, 120, 20, "", "Nickname");
+            entityName = new ListenerTextFieldElement(modelViewer, mc.font, modelViewer.width - 120, entityVariant.yPosition + 21, 120, 20, "", "Nickname");
             entityName.setTextChangeListener(modelViewer);
             buttonList.add(entityName);
         }
@@ -125,9 +125,9 @@ public class EntityCategory extends ModelViewerCategory{
         int xPos = modelViewer.width;
         int yPos = lastButton.getY() + lastButton.getHeight() + 1;
 
-        List<GuiButton> entryButtons = getEntry(displayEntity).getEntryButtons(mc, modelViewer, displayEntity);
+        List<ButtonElement> entryButtons = getEntry(displayEntity).getEntryButtons(mc, modelViewer, displayEntity);
         if (entryButtons != null){
-            for (GuiButton button : entryButtons) {
+            for (ButtonElement button : entryButtons) {
                 button.setX(button.getX() + xPos);
                 button.setY(button.getY() + yPos);
             }
@@ -190,7 +190,7 @@ public class EntityCategory extends ModelViewerCategory{
                 ((Mob) displayEntity).setSkinVariant(0);
             }
         }
-        mc.effectRenderer.clearEffects(mc.theWorld);
+        mc.particleEngine.setWorld(mc.theWorld);
         modelViewer.init();
     }
     public void removeDisplayEntity(){
@@ -198,6 +198,6 @@ public class EntityCategory extends ModelViewerCategory{
             displayEntity.remove();
             mc.theWorld.loadedEntityList.remove(displayEntity);
         }
-        mc.effectRenderer.clearEffects(mc.theWorld);
+        mc.particleEngine.setWorld(mc.theWorld);
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ModelViewerCategory.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ModelViewerCategory.java
index 821e75e33..92c1f75fe 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ModelViewerCategory.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ModelViewerCategory.java
@@ -1,22 +1,22 @@
 package net.minecraft.client.gui.modelviewer.categories;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.modelviewer.ModelViewerScreen;
 import net.minecraft.core.lang.I18n;
 
 import java.util.List;
 
 public abstract class ModelViewerCategory {
-    protected final GuiModelViewer modelViewer;
+    protected final ModelViewerScreen modelViewer;
     protected final Minecraft mc;
-    public ModelViewerCategory(GuiModelViewer modelViewer){
+    public ModelViewerCategory(ModelViewerScreen modelViewer){
         this.modelViewer = modelViewer;
         this.mc = Minecraft.getMinecraft(this);
     }
     public abstract String getCategoryNameKey();
     public abstract String getCurrentDisplayInfo(I18n translator);
-    public abstract void addContextButtons(List<GuiButton> buttonList);
+    public abstract void addContextButtons(List<ButtonElement> buttonList);
     public abstract void cycleCategoryEntry(int offset);
     public abstract void onOpen();
     public abstract void onClose();
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ParticleCategory.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ParticleCategory.java
index 4a2a5e530..5d9d2fc1e 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ParticleCategory.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/ParticleCategory.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.gui.modelviewer.categories;
 
 import net.minecraft.client.entity.particle.ParticleDispatcher;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.modelviewer.ModelViewerScreen;
 import net.minecraft.client.gui.modelviewer.categories.entries.particle.BlockFXEntry;
 import net.minecraft.client.gui.modelviewer.categories.entries.particle.BubbleFXEntry;
 import net.minecraft.client.gui.modelviewer.categories.entries.particle.GenericFXEntry;
@@ -11,7 +11,7 @@ import net.minecraft.client.gui.modelviewer.categories.entries.particle.LeafFXEn
 import net.minecraft.client.gui.modelviewer.categories.entries.particle.NoteFXEntry;
 import net.minecraft.client.gui.modelviewer.categories.entries.particle.ParticleEntry;
 import net.minecraft.client.gui.modelviewer.categories.entries.particle.RedDustFXEntry;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
+import net.minecraft.client.gui.modelviewer.elements.ListenerSliderElement;
 import net.minecraft.core.lang.I18n;
 
 import java.util.ArrayList;
@@ -26,7 +26,7 @@ public class ParticleCategory extends ModelViewerCategory{
     public double spawnRadius = 0;
     public ParticleEntry currentEntry;
 
-    public ParticleCategory(GuiModelViewer modelViewer) {
+    public ParticleCategory(ModelViewerScreen modelViewer) {
         super(modelViewer);
         initEntries();
         entriesList = new ArrayList<>(entryMap.values());
@@ -64,9 +64,9 @@ public class ParticleCategory extends ModelViewerCategory{
     }
 
     @Override
-    public void addContextButtons(List<GuiButton> buttonList) {
-        GuiButton lastButton = buttonList.get(buttonList.size()-1);
-        GuiListenerSlider radiusSlider = new GuiListenerSlider(-1, modelViewer.width - 120, lastButton.yPosition + 21, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.particle.radius.slider", ((int)(spawnRadius * 100))/100f), (float) spawnRadius);
+    public void addContextButtons(List<ButtonElement> buttonList) {
+        ButtonElement lastButton = buttonList.get(buttonList.size()-1);
+        ListenerSliderElement radiusSlider = new ListenerSliderElement(-1, modelViewer.width - 120, lastButton.yPosition + 21, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.particle.radius.slider", ((int)(spawnRadius * 100))/100f), (float) spawnRadius);
         radiusSlider.setOnValueChanged(() ->{
             spawnRadius = radiusSlider.sliderValue;
             radiusSlider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.particle.radius.slider", ((int)(spawnRadius * 100))/100f);
@@ -76,9 +76,9 @@ public class ParticleCategory extends ModelViewerCategory{
         int xPos = modelViewer.width;
         int yPos = radiusSlider.getY() + radiusSlider.getHeight() + 1;
 
-        List<GuiButton> buttons = currentEntry.getEntryButtons(mc, modelViewer);
+        List<ButtonElement> buttons = currentEntry.getEntryButtons(mc, modelViewer);
         if (buttons != null){
-            for (GuiButton button: buttons){
+            for (ButtonElement button: buttons){
                 button.setX(button.getX() + xPos);
                 button.setY(button.getY() + yPos);
             }
@@ -89,7 +89,7 @@ public class ParticleCategory extends ModelViewerCategory{
     @Override
     public void cycleCategoryEntry(int offset) {
         setCurrentEntry(entriesList.get((entriesList.indexOf(currentEntry) + entriesList.size() + offset) % entriesList.size()));
-        mc.effectRenderer.clearEffects(mc.theWorld);
+        mc.particleEngine.setWorld(mc.theWorld);
         modelViewer.init();
     }
 
@@ -101,7 +101,7 @@ public class ParticleCategory extends ModelViewerCategory{
 
     @Override
     public void onClose() {
-        mc.effectRenderer.clearEffects(mc.theWorld);
+        mc.particleEngine.setWorld(mc.theWorld);
         currentEntry.onClose();
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BasicBlockEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BasicBlockEntry.java
index 056256d7a..a7244732d 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BasicBlockEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BasicBlockEntry.java
@@ -1,10 +1,9 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.block;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.List;
@@ -20,7 +19,7 @@ public class BasicBlockEntry extends BlockEntry{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, World world, int meta) {
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, World world, int meta) {
         return null;
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntry.java
index 765800e1f..cce7e9a8c 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntry.java
@@ -1,10 +1,9 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.block;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.List;
@@ -16,7 +15,7 @@ public abstract class BlockEntry {
     }
 
     public abstract void onTick(World world, int meta);
-    public abstract List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, World world, int meta);
+    public abstract List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, World world, int meta);
     public abstract void onClose(World world, int meta);
     public abstract void onOpen(World world, int meta);
 }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/JarEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/JarEntry.java
index 9a20b985f..567fc8e79 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/JarEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/JarEntry.java
@@ -1,10 +1,10 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.block;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.GuiModelViewer;
-import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.ModelViewerScreen;
+import net.minecraft.client.gui.modelviewer.elements.TextCycleElement;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.FlowerJarBlockEntity;
@@ -26,11 +26,11 @@ public class JarEntry extends BlockEntry{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, World world, int meta) {
-        GuiTextCycle<Integer> jarCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, 0, 120, 20, 0) {
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, World world, int meta) {
+        TextCycleElement<Integer> jarCycle = new TextCycleElement<Integer>(parentScreen, mc.font, - 120, 0, 120, 20, 0) {
             @Override
             public Integer cycleElement(Integer current, int offset) {
-                return GuiModelViewer.cycleBlockId(current, offset);
+                return ModelViewerScreen.cycleBlockId(current, offset);
             }
 
             @Override
@@ -53,7 +53,7 @@ public class JarEntry extends BlockEntry{
         jarCycle.textField.setPlaceholder("Jar ID");
         jarCycle.setOnValueChanged(() -> ((FlowerJarBlockEntity)DisplayChunk.displayBlockEntity).flowerInPot = jarCycle.getCurrentElement());
 
-        return new ArrayList<GuiButton>(){{add(jarCycle);}};
+        return new ArrayList<ButtonElement>(){{add(jarCycle);}};
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/MobSpawnerEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/MobSpawnerEntry.java
index a88e0de49..fa872f3e8 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/MobSpawnerEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/MobSpawnerEntry.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.block;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.elements.GuiListSelectorButton;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.elements.ListSelectorButtonElement;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.MobSpawnerBlockEntity;
 import net.minecraft.core.entity.EntityDispatcher;
@@ -36,17 +36,17 @@ public class MobSpawnerEntry extends BlockEntry{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, World world, int meta) {
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, World world, int meta) {
         List<String> ids = new ArrayList<>(EntityDispatcher.keyToClassMap.keySet());
         ids.remove("mob");
-        GuiListSelectorButton<String> dispatcherIds = new GuiListSelectorButton<String>(-1, -120, 0, 120, 20, I18n.getInstance().translateKey("model.category.block.spawner.button.id"), ids, "Pig") {
+        ListSelectorButtonElement<String> dispatcherIds = new ListSelectorButtonElement<String>(-1, -120, 0, 120, 20, I18n.getInstance().translateKey("model.category.block.spawner.button.id"), ids, "Pig") {
             @Override
             public String getNameFromElement(String element) {
                 return element;
             }
         };
         dispatcherIds.setOnValueChanged(() -> ((MobSpawnerBlockEntity)DisplayChunk.displayBlockEntity).setMobId(dispatcherIds.getCurrentElement()));
-        return new ArrayList<GuiButton>(){{add(dispatcherIds);}};
+        return new ArrayList<ButtonElement>(){{add(dispatcherIds);}};
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/SignEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/SignEntry.java
index 0789f9652..e8282894e 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/SignEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/SignEntry.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.block;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.elements.ListenerTextFieldElement;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.SignBlockEntity;
 import net.minecraft.core.world.World;
@@ -23,17 +23,17 @@ public class SignEntry extends BlockEntry{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, World world, int meta) {
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, World world, int meta) {
         SignBlockEntity sign = (SignBlockEntity)DisplayChunk.displayBlockEntity;
-        GuiListenerTextField line1 = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, 0,                       120, 20, "", "Line 1");
-        GuiListenerTextField line2 = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, line1.yPosition + 21,    120, 20, "", "Line 2");
-        GuiListenerTextField line3 = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, line2.yPosition + 21,    120, 20, "", "Line 3");
-        GuiListenerTextField line4 = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, line3.yPosition + 21,    120, 20, "", "Line 4");
+        ListenerTextFieldElement line1 = new ListenerTextFieldElement(parentScreen, mc.font, -120, 0,                       120, 20, "", "Line 1");
+        ListenerTextFieldElement line2 = new ListenerTextFieldElement(parentScreen, mc.font, -120, line1.yPosition + 21,    120, 20, "", "Line 2");
+        ListenerTextFieldElement line3 = new ListenerTextFieldElement(parentScreen, mc.font, -120, line2.yPosition + 21,    120, 20, "", "Line 3");
+        ListenerTextFieldElement line4 = new ListenerTextFieldElement(parentScreen, mc.font, -120, line3.yPosition + 21,    120, 20, "", "Line 4");
         line1.setOnValueChanged(() -> sign.signText[0] = line1.getText());
         line2.setOnValueChanged(() -> sign.signText[1] = line2.getText());
         line3.setOnValueChanged(() -> sign.signText[2] = line3.getText());
         line4.setOnValueChanged(() -> sign.signText[3] = line4.getText());
-        return new ArrayList<GuiButton>(){
+        return new ArrayList<ButtonElement>(){
             {
                 add(line1);
                 add(line2);
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/BlankEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/BlankEntry.java
index 9766af221..0067a45f5 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/BlankEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/BlankEntry.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.world.World;
 
@@ -15,7 +15,7 @@ public class BlankEntry extends EntityEntry<Entity> {
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, Entity entity) {
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, Entity entity) {
         return null;
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/DispatcherEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/DispatcherEntry.java
index f0ac1a7cf..420c7c293 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/DispatcherEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/DispatcherEntry.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.world.World;
@@ -20,7 +20,7 @@ public class DispatcherEntry extends EntityEntry<Entity> {
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, Entity entity) {
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, Entity entity) {
         return null;
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityArmoredZombieEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityArmoredZombieEntry.java
index 7ec452b4b..1b5d031e0 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityArmoredZombieEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityArmoredZombieEntry.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.core.entity.monster.ZombieArmoredMob;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
@@ -18,9 +18,9 @@ public class EntityArmoredZombieEntry extends EntityEntry<ZombieArmoredMob>{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, ZombieArmoredMob armoredZombie) {
-        List<GuiButton> buttonList = new ArrayList<>();
-        GuiListenerButton swordButton = new GuiListenerButton(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.armored_zombie.button.sword", false));
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, ZombieArmoredMob armoredZombie) {
+        List<ButtonElement> buttonList = new ArrayList<>();
+        ListenerButtonElement swordButton = new ListenerButtonElement(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.armored_zombie.button.sword", false));
         swordButton.setActionListener(() -> {
             boolean hasSword1 = armoredZombie.getHeldItem() != null;
             armoredZombie.setHoldingSword(!hasSword1);
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityBoatEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityBoatEntry.java
index c9085d1b9..882226a60 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityBoatEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityBoatEntry.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.core.block.entity.FlagBlockEntity;
 import net.minecraft.core.entity.vehicle.BoatEntity;
 import net.minecraft.core.lang.I18n;
@@ -19,8 +19,8 @@ public class EntityBoatEntry extends EntityEntry<BoatEntity>{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, BoatEntity entity) {
-        GuiListenerButton flagButton = new GuiListenerButton(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.boat.button.flag", false));
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, BoatEntity entity) {
+        ListenerButtonElement flagButton = new ListenerButtonElement(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.boat.button.flag", false));
         flagButton.setActionListener(() -> {
             boolean flag;
             if (entity.tileEntityFlag == null){
@@ -32,7 +32,7 @@ public class EntityBoatEntry extends EntityEntry<BoatEntity>{
             }
             flagButton.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.boat.button.flag", flag);
         });
-        return new ArrayList<GuiButton>(){{add(flagButton);}};
+        return new ArrayList<ButtonElement>(){{add(flagButton);}};
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityCreeperEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityCreeperEntry.java
index c495ec7ba..c6095b9e4 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityCreeperEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityCreeperEntry.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.entity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.core.entity.monster.CreeperMob;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
@@ -18,10 +18,10 @@ public class EntityCreeperEntry extends EntityEntry<CreeperMob>{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, CreeperMob creeper) {
-        List<GuiButton> buttonList = new ArrayList<>();
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, CreeperMob creeper) {
+        List<ButtonElement> buttonList = new ArrayList<>();
         boolean isCharged = creeper.getPowered();
-        GuiListenerButton chargedToggle = new GuiListenerButton(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.creeper.button.charged", isCharged));
+        ListenerButtonElement chargedToggle = new ListenerButtonElement(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.creeper.button.charged", isCharged));
         chargedToggle.setActionListener(() -> {
             boolean isCharged1 = creeper.getPowered();
             isCharged1 = !isCharged1;
